require "./config"
require "socket"
CONFIG = Config.load

module TwitchIRC
  class Client
    @client : TCPSocket

    def initialize(username : String, oauth_token : String)
      begin   
        @client = TCPSocket.new("irc.chat.twitch.tv", 6667)
        sendraw("CAP REQ :twitch.tv/membership twitch.tv/tags twitch.tv/commands")
        sendraw("PASS #{oauth_token}")
        sendraw("NICK #{username}")
      rescue ex
        puts ex
      end
    end
    
    def join(channel : String | Array(String))
      if channel.is_a?(Array) 
        channel.each do |c|
          sendraw("JOIN ##{c}")
        end
      else
        sendraw("JOIN ##{channel}")
      end
    end

    def sendraw(message : String)
      @client << "#{message}\n"
    end

    def sendmsg(message : String, channel : String)
      sendraw("PRIVMSG ##{channel} :#{message}")
    end

    def listen
      spawn do
        loop do
          begin
            puts @client.gets
          rescue ex
            puts ex
          end
          Fiber.yield
        end
      end
    end
  end
end

asd = TwitchIRC::Client.new(CONFIG.nick, CONFIG.oauth_token)
asd.listen
asd.join("fijxu")
asd.sendmsg("retardcrystaltest", "fijxu")

sleep